routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});
Route::group(['prefix' => 'admin', 'namespace' => 'Admin','as'=>'admin.'], function () {
    Route::get('/', 'AdminController@index')->name('index');
    Route::group(['prefix' => 'category','as'=>'category.'], function () {
        Route::get('/', 'CategoryController@index')->name('list');
        Route::get('/add', 'CategoryController@create')->name('add');
        Route::post('/created', 'CategoryController@store')->name('created');
        Route::get('edit/{id}', 'CategoryController@edit')->name('edit');
        Route::put('/{id}', 'CategoryController@update')->name('update');
        Route::delete('/category/{id}', 'CategoryController@destroy')->name('destroy');
    });
    Route::group(['prefix' => 'product','as'=>'product.'], function () {
        Route::get('/', 'ProductController@index')->name('list');
        Route::get('/add', 'ProductController@create')->name('add');
        Route::post('/created', 'ProductController@store')->name('created');
        Route::get('edit/{id}', 'ProductController@edit')->name('edit');
        Route::post('/{id}', 'ProductController@update')->name('update');
        Route::delete('/product/{id}', 'ProductController@destroy')->name('destroy');
         Route::post('uploadimage/{type?}', 'ProductController@uploadImage')->name('uploadimage');
           Route::post('/deleteimage', 'ProductController@deleteImage')->name('deleteimage');
    });
});

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
   protected $fillable=['id','name','color','price','market_price','quantity','detail','origin','warranty','user_id','category_id','comment_id','img_pd_id','status','view'];

   public function category()
   {
   		return $this->belongsTo('App\Models\Category','category_id');
   }

    public function images()
    {
        return $this->morphMany(Image::class, 'imagetable');
    }
}

app/Http/Controllers/Admin/ProductController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Category;
use App\Models\Product;
use App\Models\Image;
use File;
use App\Http\Requests\ProductRequest;
use Illuminate\Support\Facades\DB;

class ProductController extends Controller
{

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    protected $categories;

    public function __construct()
    {
        $this->categories = Category::select()->get();
    }

    public function index()
    {

        $products = Product::with('category')->select()->paginate(5);
        return view('AdminPage.product.list',
            [
                'products' => $products
            ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $categories = $this->categories;
        return view('AdminPage.product.createOrUpdate', compact('categories'));
    }


    public function handleStoreOrUpdate($request, $id = null)
    {
        $dataInput = array_merge($request->all(), [
            'user_id' => 1,
        ]);
        $product = Product::create($dataInput);
        foreach ($request->image as $val) {
            $dataImage['src'] = $val['src'];
            $dataImage['alt'] = "img";
            $dataImage['description'] = "test";
            $product->images()->create($dataImage);
          
        }
        return $product;
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(ProductRequest $request)
    {
        $this->handleStoreOrUpdate($request);
        return redirect()->route('admin.product.list');
    }

    /**
     * Display the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
         $categories = $this->categories;
        $product = Product::findOrFail($id);
        return view('AdminPage.product.update',['product'=> $product,
        'categories' => $categories]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $images_request = $request->image;
        dd($images_request);
        $product = Product::findOrFail($id);
        $images_data = $product->images()->pluck('id')->toArray();
        foreach($images_request as $value){
            // dd($value['id']);
            if(empty($value['id']) && !in_array($value['id'], $images_data)){
                // $product->images()->create();
                echo "tao moi ";
                echo "<br>";
            }else{
                echo "update";
                 echo "<br>";
                 $pos = array_search($value, $images_data); 
                 unset($images_data[$pos]); 
            }
        }
        dd($images_data);
        if(sizeof($images_data) > 0 ){
            $listImageDel = Image::whereIn('id',$images_data)->get();
                echo "xoa";
                 echo "<br>";
                // foreach ($listImageDel as $key => $value) {
                //     $value->delete();

                // }
        }
        exit;
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $products = Product::findOrFail($id);
        $products->delete();
        return redirect()->route('admin.product.list');
    }

    public function uploadImage($type = null, Request $request)
    {
        $extension = $request->file('file')->getClientOriginalExtension();
        if ($type) {
            $dir = 'uploads/' . $type . '/';
        } else {
            $dir = 'uploads/';
        }
        $filename = uniqid() . '_' . time() . '.' . $extension;
        $request->file('file')->move($dir, $filename);
        $nameAndPatch = $dir . $filename;
        return json_encode(['status' => true, 'filename' => $nameAndPatch]);
    }

    public function deleteImage(Request $request)
    {
        // $srcImg = $request->srcImg;
        // $srcImg = public_path() . $srcImg;
        // if ($srcImg != public_path() . '/uploads/upload.png') {
        //     File::delete($srcImg);
            // return json_encode(['status' => true,]);
        // }
    }
}

resources/views/AdminPage/product/createOrUpdate.blade.php
@extends('Adminpage.layouts.master')
@section('styles')
    <style type="text/css" media="screen">
        select option {
            color: #005f89;
        }

        label {
            text-transform: capitalize;
        }
    </style>
    <script src="/ckeditor/ckeditor.js"></script>
@endsection
@section('content')
    <div class="row">
        <div class="col-md-12">

            <div class="card ">
                <div class="card-header">
                    <h4 class="card-title">@if(isset($product)) Update Prodcut @else Create Product @endif</h4>
                </div>
                @if ($errors->any())
                    <div class="alert alert-danger">
                        <ul>
                            @foreach ($errors->all() as $error)
                                <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div>
                @endif
                <div class="card-body">
                    <div class="table-responsive">
                        <form action="{{route('admin.product.created')}}" method="post">
                            @csrf
                            <div class="form-group">
                                <label for="Name Product">Name Product</label>
                                <input type="text" class="form-control" name="name" placeholder="Iphone 7 plus" value="{{old('name',isset($product->name) ? $product->name:'') }}">
                            </div>
                            <div class="form-group">
                                <label for="Color">Color</label>
                                <input type="text" class="form-control" name="color" placeholder="Rose Gold" value="{{old('color',isset($product->color) ? $product->color:'') }}">
                            </div>
                            <div class="form-group">
                                <label for="Categories">Categories</label>
                                <select class="form-control" id="" name="category_id">
                                    @foreach($categories as $category)
                                        <option value="{{$category->id}}"{{isset($product) ? ($category->id == $product->category_id ? 'selected' : '') : '' }} >{{$category->name}}</option>
                                    @endforeach
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="price">price</label>
                                <input type="text" class="form-control" name="price" placeholder="VNĐ" value="{{old('price',isset($product->price) ? $product->price:'') }}">
                            </div>
                            <div class="form-group">
                                <label for="market price">market price</label>
                                <input type="text" class="form-control" name="market_price" placeholder="VNĐ" value="{{old('market_price',isset($product->market_price) ? $product->market_price:'') }}">
                            </div>
                            <div class="form-group">
                                <label for="quantity">quantity</label>
                                <input type="text" class="form-control" name="quantity" placeholder="Số lượng" value="{{old('quantity',isset($product->quantity) ? $product->quantity:'') }}">
                            </div>
                            <div class="form-group">
                                <label for="origin">origin</label>
                                <input type="text" class="form-control" name="origin" placeholder="Viet Nam" value="{{old('origin',isset($product->origin) ? $product->origin:'') }}">
                            </div>
                            <div class="form-group">
                                <label for="warranty">warranty</label>
                                <input type="number" class="form-control" name="warranty" placeholder="Số tháng" value="{{old('warranty',isset($product->warranty) ? $product->warranty:'') }}">
                            </div>
                            <div class="form-group">
                                <div class="col-md-12 image_content">
                                    <div class="row">
                                        <button type="button" class="btn btn-primary btn_addimg" value="0">Thêm Hình
                                        </button>
                                    </div>
                                    <div class="Add_img">
                                        <?php 
                                        // dd(old('image'));
                                         ?>
                                        @if(old('image'))
                                        @foreach(old('image') as $key => $img)
                                        <div class="row item-image" style="border:2px solid;margin-bottom:10px;">
                                            <div class="col col-md-4">
                                                <label for="file-input" class=" form-control-label">File input</label> 
                                                <input type="file" id="file-input{{$key}}" name="image_upload filesTest" class="form-control-file upload-image" onchange="UploadImage(this);">
                                            </div>
                                            <div class="col col-md-6">
                                                <label for="file-input" class=" form-control-label">Image view</label><br>
                                                <span class="imageResult">
                                                    <img src="/{{isset($img['src']) ? $img['src'] : null }}" class="image_show" id="image_show{{$key}}" width="100px" height="100px">
                                                    <input type="hidden" name="image[{{$key}}][src]" id="images_show_data{{$key}}" value="{{$img['src']}}">
                                                </span>
                                            </div>
                                            <div class="col col-md-2" style="text-align: center;padding: 40px;">
                                                <button type="button" class="btn btn-danger" onclick="deleteItemimage(this);">Xóa</button>
                                            </div>
                                        </div>
                                        @endforeach
                                        @endif
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="detail">detail</label>
                                <textarea name="detail" id="detail" rows="10" cols="80">
						This is my textarea to be replaced with CKEditor.
						</textarea>
                                <script>
                                    // Replace the <textarea id="detail"> with a CKEditor
                                    // instance, using default configuration.
                                    CKEDITOR.replace('detail');
                                </script>
                            </div>
                            <fieldset class="form-group">
                                <div class="row">
                                    <legend class="col-form-label col-sm-2 pt-0">Status</legend>
                                    <div class="col-sm-10">
                                        <div class="form-check">
                                            <input class="form-check-input" type="radio" name="status" id="gridRadios1"
                                                   value="1" checked>
                                            <label class="form-check-label" for="gridRadios1">
                                                Active
                                            </label>
                                        </div>
                                        <div class="form-check">
                                            <input class="form-check-input" type="radio" name="status" id="gridRadios2"
                                                   value="2">
                                            <label class="form-check-label" for="gridRadios2">
                                                Not Active
                                            </label>
                                        </div>
                                    </div>
                                </div>
                            </fieldset>
                            <div class="col-auto">
                                <button type="submit" class="btn btn-primary mb-2">Submit</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection
@section('scripts')
    <script type="text/javascript">
        $('.btn_addimg').click(function () {
            var countImage = $('.Add_img').find('.item-image').length + 1;
            var src = 'src';
            if (countImage > 6) {
                alert("Không được quá 6 tấm hình");
            } else {
                $('.Add_img').append(
                    '<div class="row item-image" style="border:2px solid;margin-bottom:10px;">'
                    + '<div class="col col-md-4">'
                    + '<label for="file-input" class=" form-control-label">File input</label> '
                    + '<input type="file" id="file-input' + countImage + '" name="image_upload filesTest" class="form-control-file upload-image" onchange="UploadImage(this);">'
                    + '</div>'
                    + '<div class="col col-md-6">'
                    + '<label for="file-input" class=" form-control-label">Image view</label><br>'
                    + '<span class="imageResult">'
                    + '<img src="/uploads/upload.png" class="image_show" id="image_show' + countImage + '" width="100px" height="100px">'
                    + '<input type="hidden" name="image[' + countImage +'][src]" id="images_show_data' + countImage + '" value="">'
                    + '</span>'
                    + '</div>'
                    + '<div class="col col-md-2" style="text-align: center;padding: 40px;">'
                    + '<button type="button" class="btn btn-danger" onclick="deleteItemimage(this);">Xóa</button>'
                    + '</div>'
                    + '</div>'
                )
            }
        });

        function UploadImage(e) {
            // console.log(e);
            var a = $(e).parent('div').parent('div').find('span.imageResult');
            var b = $(a).children('img').attr('id');
            var c = $(a).children('input').attr('id');
            var b2 = '#' + b;
            var c2 = '#' + c;
            console.log(e.files[0]);
            var form_data = new FormData();
            form_data.append('file', e.files[0]);
            form_data.append('_token', '{{csrf_token()}}');
            $.ajax({
                url: "{{route('admin.product.uploadimage',['type'=>'products'])}}", // Url to which the request is send
                data: form_data,
                type: 'POST',
                contentType: false,
                processData: false,
                success: function (res)   // A function to be called if request succeeds
                {
                    $(b2).attr('src', '');
                    $(c2).val('');
                    dataSuccess = JSON.parse(res);
                    $(b2).attr('src', '/' + dataSuccess.filename);
                    $(c2).val(dataSuccess.filename);
                }, error: function (error) {
                    alert(error);
                }
            });
        };

        function deleteItemimage(e) {
            console.log(e);
            var a = $(e).parent('div').parent('div').find('span.imageResult');
            var srcImg = $(a).children('img').attr('src');
            var data_Img = new FormData();
            data_Img.append('srcImg', srcImg);
            data_Img.append('_token', '{{csrf_token()}}');
            $.ajax({
                url: "{{route('admin.product.deleteimage')}}",
                type: 'POST',
                data: data_Img,
                contentType: false,
                processData: false,
                success: function (res)   // A function to be called if request succeeds
                {
                    var d =  $(e).parent();
                    $(d).parent('.item-image').remove();
                    var num = +$(".btn_addimg").val() - 1;
                    $(".btn_addimg").val(num);
                }, error: function (error) {
                    alert(error);
                }
            });
        };
    </script>
@endsection

resources/views/AdminPage/product/list.blade.php
@extends('Adminpage.layouts.master')
@section('content')
<div class="row">
	<div class="col-md-12">

		<div class="card ">
			<div class="card-header">
				<h4 class="card-title"> Products Table</h4>
			</div>
			<div class="row">
			<div class="col-md-6">
				<a class="btn btn-success text-center" href="{{route('admin.product.add')}}" style="width: 100%;margin-bottom: 10px;">
				Add </a>
			</div>         
		</div>
			<div class="card-body">
				<div class="table-responsive">
					<table class="table tablesorter " id="">
						<thead class=" text-primary">
							<tr>
								<th>
									ID
								</th>
								<th>
									Name
								</th>
								<th>
									Color
								</th>
								<th class="text-center">
									Price
								</th>
								<th class="text-center">
									Market Price
								</th>
								<th class="text-center">
									Quantity
								</th>
								<th class="text-center">
									Category
								</th>
								<th class="text-center">
									Status
								</th>
							</tr>
						</thead>
						<tbody>
						@if($products)
							@foreach($products as $product)
								<tr>
									<td>
										{{$product->id}}
									</td>
									<td>
										{{$product->name}}
									</td>
									<td>
										{{$product->color}}
									</td>
									<td class="text-center">
										{{$product->price}}
									</td>
									<td class="text-center">
										{{$product->market_price}}
									</td>
									<td class="text-center">
										{{$product->quantity}}
									</td>
									<td class="text-center">
										{{$product->category->name}}
									</td>
									<td>
										{{$product->status}}
									</td>
									<td>
										<a class="btn btn-primary" href="{{route('admin.product.edit',['id'=>$product->id])}}">Update</a>
									</td>
									<td>
										<form action="{{route('admin.product.destroy',['id'=>$product->id])}}" method="POST">
										@method('DELETE')
										@csrf
										<button class="btn btn-danger">Delete</button>
										</form>    
									</td>
								</tr>
							@endforeach
						@endif

						</tbody>
					</table>
				</div>
			</div>
			<div class="row" style="margin:0 auto;">
				{{$products->links()}}
			</div>
		</div>
	</div>
</div>
@endsection